         TITLE '3286 PRINT FILE UTILITY  V1.10'                         00001000
         PRINT NOGEN                                                    00002000
* Program uses attached 3286 printer at CUU X'080' to print a file.     00003000
*   (should also work with 3284, 3287, or 3288 because buffer is        00004000
*    cleared after every write)                                         00005000
*                                                                       00006000
* Paul McGinnis 2/27/92  JDS MICROPROCESSING, EL TORO, CA, USA          00007000
* Internet: TRADER@cup.portal.com                                       00008000
* CIS: 76056,201                                                        00009000
* America Online: PaulMcG                                               00010000
* GEnie: EXP.ENG-                                                       00011000
* US Snail:  P.O. Box 28084                                             00012000
*            Santa Ana, CA  92799                                       00013000
*                                                                       00014000
*   (Program tested with VM/SP Release 5, VM/XA Release 2.1)            00015000
*                                                                       00016000
* THIS PROGRAM IS PUBLIC DOMAIN. WHICH MEANS THE AUTHOR ASSUMES NO      00017000
* LIABILITY FOR THE USE OR MISUSE OF IT. IF IT BOMBS...THE AUTHOR       00018000
* MAY OR NOT BE ABLE TO FIX IT...                                       00019000
*                                                                       00020000
* changes summary:                                                      00021000
*   v1.10-form feed after 56 lines, use standard VM interrupt handler,  00022000
*       notify users when channel error occur.                          00023000
*   v1.03-fixed bug with lines longer than 132 columns not printing     00024000
*   v1.02-changed channel routine to be interrupt driven, not polled    00025000
*   v1.01-changed program to use SIO/TIO instead of CONSOLE macro       00026000
*                                                                       00027000
*   To assemble, use these commands on VM/SP or HPO.                    00028000
*     GLOBAL MACLIB DMSSP CMSLIB                                        00029000
*     ASSEMBLE PRT86                                                    00030000
*     LOAD PRT86                                                        00031000
*     GENMOD PRT86 (SYSTEM                                              00032000
*                                                                       00033000
*   To assemble, use these commands on VM/SP or HPO.                    00034000
*     GLOBAL MACLIB DMSGPI DMSOM                                        00035000
*     ASSEMBLE PRT86                                                    00036000
*     LOAD PRT86 (CLEAR                                                 00037000
*     GENMOD PRT86 (SYSTEM                                              00038000
*                                                                       00039000
         MACRO                                                          00040000
&LABEL   HEXTOC              &BUF1,&BUF2                                00041000
.* SIMPLE MACRO TO DO HEX-TO-EBCDIC CONVERSION - BUF1 CONTAINS THE      00042000
.* ADDRESS OF A BYTE TO TRANSLATE, BUF2 IS THE ADDRESS OF 2 BYTES TO    00043000
.* PLACE THE CHARACTER OUTPUT IN. ---- PAUL MCGINNIS  11/89             00044000
.*                                                                      00045000
.* NOTE: USES REGISTER R1                                               00046000
         CNOP  0,4                GET THIS THING ALIGNED                00047000
         SR    1,1                CLEAR R1                              00048000
         IC    1,&BUF1            MOVE BYTE INTO R1                     00049000
         SRL   1,4                CLEAR EVERYTHING BUT HIGH-ORDER BITS  00050000
         CL    1,=XL4'09'         SEE IF IT IS HIGHER THAN 9---CHAR     00051000
         BH    H&SYSNDX           GO MAKE IT A CHARACTER                00052000
         AL    1,=XL4'F0'         ADD X'F0' TO MAKE IT EBCDIC NUMBER    00053000
         B     I&SYSNDX           GO TO NEXT PART OF ROUTINE            00054000
H&SYSNDX AL    1,=XL4'B7'         RANGE WILL BE FROM X'C1'-X'C6'        00055000
.* ROUTINE DOES CRUDE CONVERSION--JUST MAKES IT A RAW CHARACTER         00056000
I&SYSNDX STC   1,&BUF2            PUT CONTENTS OF R1 IN OUTPUT BUFFER   00057000
         SR    1,1                CLEAR R1                              00058000
         IC    1,&BUF1            MOVE BYTE INTO R1                     00059000
         N     1,=XL4'0F'         MASK OFF HIGH 4 BITS W/ LOGICAL AND   00060000
         CL    1,=XL4'09'         SEE IF IT IS HIGHER THAN 9---CHAR     00061000
         BH    J&SYSNDX           GO MAKE IT A CHARACTER                00062000
         AL    1,=XL4'F0'         ADD X'F0' TO MAKE IT EBCDIC NUMBER    00063000
         B     K&SYSNDX           GO TO NEXT PART OF ROUTINE            00064000
J&SYSNDX AL    1,=XL4'B7'         RANGE WILL BE FROM X'C1'-X'C6'        00065000
K&SYSNDX STC   1,&BUF2+1          PUT CONTENTS OF R1 IN 2ND BYTE        00066000
         MEND                                                           00067000
PRT86    CSECT                                                          00068000
         STM   R14,R12,12(R13)       SAVE ALL REGS IN OLD SAVE AREA     00069000
         BALR  R12,0                 USE R12 FOR BASE REGISTER          00070000
         USING *,R12                                                    00071000
         LR    R14,R13              STORE ALL REGS IN NEW SAVE AREA     00072000
         LA    R13,MAINSAVE                                             00073000
         ST    R14,4(R13)                                               00074000
         ST    R13,8(R14)                                               00075000
* NOW, FINALLY, THE PROGRAM STARTS                                      00076000
         LA    R2,8(R1)            GET ADDRESS OF REST OF COMMAND       00077000
         ST    R2,FILEADD          SAVE FILE ID ADDRESS                 00078000
         LINEWRT DATA=MSG0         SEND DESCRIPTION OF PROGRAM          00079000
         CLI   0(R2),X'FF'         ANY FILE NAME?                       00080000
         BNE   TIO1                YES, SO LEAVE THE USER ALONE.        00081000
         LINEWRT DATA=MSG1          USER NEEDS TO SPECIFY A FILE        00082000
         LA    R15,200             SET RETURN CODE TO 200               00083000
         ST    R15,RETCODE         STORE IT                             00084000
         B     EOJ                 AND EXIT                             00085000
         LINEWRT DATA=MSG2          SEND MSG ABOUT DEVICE TEST          00086000
TIO1     EQU   *                                                        00087000
         LA    R5,PRTCUU            GET ADDRESS OF VIRTUAL 328X         00088000
         TIO   0(R5)                SEE IF DEVICE IS OUT THERE.         00089000
         BC    14,OPEN              YES, IT IS                          00090000
TIO2     EQU   *                                                        00091000
         LA    R15,100             SET RETURN CODE TO 100               00092000
         ST    R15,RETCODE         SAVE ERROR RETURN CODE               00093000
         LINEWRT DATA=MSG3          SEND MSG ABOUT DEVICE PROBLEM       00094000
         B     EOJ                 AND EXIT                             00095000
OPEN     EQU   *                                                        00096000
         HNDIO SET,DEVNAME=PR86,EXIT=INTHNDL,DEVICE=(R5),              X00097000
               NOTIFY=WAIT                                              00098000
* SET UP I/O INTERRUPT HANDLER FOR PRINTER                              00099000
         FSSTATE (2),ERROR=ERRFILE   GET FILE INFORMATION               00100000
* RETURN CODES FROM FSSTATE MACRO ARE:                                  00101000
* 20 = INVALID CHARACTER IN FILE ID                                     00102000
* 24 = INVALID FILEMODE                                                 00103000
* 28 = FILE NOT FOUND                                                   00104000
* 36 = MINIDISK NOT ACCESSED                                            00105000
         L     R2,FILEADD           GET ADDRESS OF FILE POINTER         00106000
         FSOPEN (2),FSCB=INFILE,ERROR=ERRFILE      OPEN INPUT FILE      00107000
* RETURN CODES FROM FSOPEN MACRO ARE:                                   00108000
* 20 = INVALID CHARACTER IN FILE ID                                     00109000
* 28 = FILE NOT FOUND                                                   00110000
         B     START0               GO TO MAIN LOOP                     00111000
ERRFILE  EQU    *                                                       00112000
         ST    R15,RETCODE      SAVE RETURN CODE FROM ERROR             00113000
         LINEWRT DATA=MSG4       TELL USER ABOUT FILE ERROR             00114000
         B     EOJ              AND EXIT                                00115000
START0   EQU    *                                                       00116000
         LINEWRT DATA=MSG5       SEND PRINTING... MSG                   00117000
         XR    R6,R6            CLEAR LINE COUNT                        00118000
PRTLOOP  EQU   *                                                        00119000
         MVI   INBUF,C' '         SET FIRST BYTE OF BUFFER TO SPACE     00120000
         MVC   INBUF+1(132),INBUF    AND RIPPLE FOR REST OF BUFFER      00121000
         LA    R8,LOOP2             GET SUBROUTINE RETURN ADDRESS       00122000
         ST    R8,RETADDR           AND SAVE IT                         00123000
         FSREAD FSCB=INFILE,BSIZE=132,ERROR=READERR                     00124000
* READ UP TO 132 BYTES                                                  00125000
LOOP2    EQU   *                                                        00126000
         LR    R3,R0                PUT BYTE COUNT IN USEABLE PLACE     00127000
         CH    R3,=H'80'            DID WE GET MORE THAN 80 BYTES?      00128000
         BH    DO132                YES, SO HANDLE IT                   00129000
         MVI   OUTBUF,X'7B'         SET WCC FOR FIXED LENGTH            00130000
         AH    R3,=H'1'             INCREMENT LENGTH TO 81 BYTES        00131000
* FIXED LENGTH 80 BYTE BUFFER + 3270 WCC                                00132000
         STH   R3,EWCCW+6           SET LENGTH TO 81 BYTES              00133000
         B     LOOP3                AND GO DO I/O                       00134000
DO132    EQU   *                                                        00135000
         MVI   OUTBUF,X'4B'      SET 3270 WCC FOR VARIABLE LENGTH       00136000
         CH    R3,=H'133'           IS IT MORE THAN 132 BYTES?          00137000
         BL    DO132A               NO, SO HANDLE NORMALLY              00138000
         LA    R3,132               TRUNCATE DATA                       00139000
DO132A   EQU   *                                                        00140000
         LA    R4,INBUF             GET ADDRESS OF INPUT BUFFER         00141000
         AR    R4,R3                AND ADD OFFSET                      00142000
         MVI   0(R4),X'15'          STORE NEWLINE CHARACTER             00143000
         AH    R3,=H'1'             INCREMENT LENGTH COUNT              00144000
         STH   R3,EWCCW+6           PUT IN CCW LENGTH                   00145000
LOOP3    EQU   *                                                        00146000
         LA    R1,EWCCW             GET ADDRESS OF ERASE/WRITE CCW      00147000
         ST    R1,VMCAW             SAVE CCW ADDRESS IN CAW             00148000
         LA    R5,PRTCUU            GET ADDRESS OF VIRTUAL 328X         00149000
         XC    CSW(8),CSW           CLEAR OLD CSW                       00150000
         SIO   0(R5)                START I/O TO 328X                   00151000
         BC    1,TIO2               NO DEVICE PRESENT-EXIT WITH ERROR   00152000
         BC    2,LOOP3              RESTART IF BUSY                     00153000
         TM    CSW+4,X'02'          UNIT CHECK IN INITIAL STATUS?       00154000
         BNZ   LOOP35               YES, SO ISSUE SENSE                 00155000
         TM    CSW+5,X'FF'          ANY CHANNEL ERRORS?                 00156000
         BNZ   LOOP4                YES, SO EXIT OUT                    00157000
         WAITD PR86                 WAIT FOR I/O INTERRUPT              00158000
         TM    CSW+4,X'02'          UNIT CHECK POSTED?                  00159000
         BZ    LOOP4                NO, SO CONTINUE                     00160000
LOOP35   EQU   *                                                        00161000
         LA    R1,SNSCCW            GET ADDRESS OF SENSE CCW            00162000
         ST    R1,VMCAW             SAVE CCW ADDRESS IN CAW             00163000
         LA    R5,PRTCUU            GET ADDRESS OF VIRTUAL 328X         00164000
         SIO   0(R5)                START I/O TO 328X                   00165000
         BC    1,TIO2               NO DEVICE PRESENT-EXIT WITH ERROR   00166000
         BC    2,LOOP35             RESTART IF BUSY                     00167000
         WAITD PR86                 WAIT FOR I/O INTERRUPT              00168000
         TM    SNSBUF,X'40'         INTERVENTION REQUIRED?              00169000
         BO    INTREQ               YES, SO ALERT USER                  00170000
         HEXTOC SNSBUF,IPT6         CONVERT SENSE CODE FROM HEX         00171000
         LA    R15,400              SET RETURN CODE TO 400              00172000
         ST    R15,RETCODE          SAVE RETURN CODE                    00173000
         LINEWRT DATA=MSG6          ALERT USER ABOUT UNIT CHECK         00174000
         B     EOJ                  AND EXIT                            00175000
LOOP4    EQU   *                                                        00176000
         TM    CSW+5,X'FF'          ANY CHANNEL ERRORS?                 00177000
         BZ    LOOP5                NO, SO CONTINUE                     00178000
         HEXTOC CSW+5,IPT8          CONVERT CHANNEL STATUS FROM HEX     00179000
         LA    R15,500              SET RETURN CODE TO 500              00180000
         ST    R15,RETCODE          SAVE RETURN CODE                    00181000
         LINEWRT DATA=MSG8          ALERT USER ABOUT UNIT CHECK         00182000
         B     EOJ                  AND EXIT                            00183000
LOOP5    EQU   *                                                        00184000
         AH    R6,=H'1'             INCREMENT NUMBER OF LINES SENT      00185000
         CH    R6,=H'56'            HAVE WE DONE 56 LINES?              00186000
         BL    PRTLOOP              NO, SO KEEP LOOPING                 00187000
         XR    R6,R6                CLEAR LINE COUNT                    00188000
LOOP55   EQU   *                                                        00189000
         LA    R1,FFCCW             GET ADDRESS OF FORMFEED CCW         00190000
         ST    R1,VMCAW             SAVE CCW ADDRESS IN CAW             00191000
         LA    R5,PRTCUU            GET ADDRESS OF VIRTUAL 328X         00192000
         SIO   0(R5)                START I/O TO 328X                   00193000
         BC    1,TIO2               NO DEVICE PRESENT-EXIT WITH ERROR   00194000
         BC    2,LOOP55             RESTART IF BUSY                     00195000
         WAITD PR86                 WAIT FOR I/O INTERRUPT              00196000
         B     PRTLOOP              START LOOP OVER AGAIN               00197000
INTREQ   EQU   *                                                        00198000
         LINEWRT DATA=PROMPT0                                           00199000
         LINERD DATA=WAITBUF,PROMPT=PROMPT1,WAIT=YES                    00200000
* TELL USER ABOUT INTERVENTION REQUIRED AND TRY CCW AGAIN               00201000
         B     LOOP3                                                    00202000
EOJ      EQU   *                                                        00203000
         HNDIO CLR,DEVNAME=PR86    REMOVE INTERRUPT HANDLER             00204000
         L     R13,4(R13)       EXIT LINKAGE                            00205000
         L     R14,12(R13)      GET BRANCH ADDRESS                      00206000
         L     R15,RETCODE      PUT RETURN CODE IN R15                  00207000
         LM    R0,R12,20(R13)   GET REST OF REGISTERS                   00208000
         BR    R14              AND EXIT...                             00209000
*                                                                       00210000
READERR  EQU   *                                                        00211000
* SUBROUTINE TO HANDLE FILE READ ERRORS                                 00212000
         STM   R14,R12,12(R13)   SAVE ALL REGS IN NEW SAVE AREA         00213000
         LR    R4,R15            PRESERVE RETURN CODE                   00214000
* READ ERROR RETURN CODES ARE AS FOLLOWS                                00215000
* 1 = FILE NOT FOUND                                                    00216000
* 2 = INVALID BUFFER ADDRESS                                            00217000
* 3 = I/O ERROR                                                         00218000
* 5 = FILE HAS NO RECORDS                                               00219000
* 7 = INVALID RECORD FORMAT                                             00220000
* 8 = BUFFER SIZE TOO SMALL. RECORD TRUNCATED                           00221000
* 9 = 800 BYTE FORMAT DISK                                              00222000
* 11 = NUMBER OF RECORDS GREATER THAN 1                                 00223000
* 12 = END-OF-FILE                                                      00224000
* 13 = INVALID DISPLACEMENT IN FILE TABLE                               00225000
* 14 = INVALID CHARACTER IN FILENAME                                    00226000
* 15 = INVALID CHARACTER IN FILETYPE                                    00227000
* 19 = I/O ERROR ON FBA DEVICE                                          00228000
* 25 = INSUFFICIENT MEMORY FOR FILE MANAGEMENT                          00229000
* 26 = REQUESTED RECORD UNAVAILABLE                                     00230000
         CL    R4,=F'8'          DATA TRUNCATED                         00231000
         BE    RDEXIT            SO WHAT                                00232000
         CL    R4,=F'11'         MORE THAN 1 VARIABLE LENGTH RECORD     00233000
         BE    RDEXIT            SO WHAT                                00234000
         CL    R4,=F'12'         END-OF-FILE                            00235000
         BE    RDCLOSE           CLEAN-UP AND LEAVE                     00236000
         ST    R4,RETCODE        SAVE ERROR CODE                        00237000
         B     EOJ               AND EXIT                               00238000
RDCLOSE  EQU   *                                                        00239000
         LINEWRT DATA=MSG7        SEND END OF JOB MESSAGE               00240000
         FSCLOSE FSCB=INFILE      CLOSE INPUT FILE                      00241000
         B     EOJ               AND EXIT                               00242000
RDEXIT   EQU    *                                                       00243000
         LM    R14,R12,12(R13)   RESTORE REGISTERS                      00244000
         L     R14,RETADDR       GET RETURN ADDRESS                     00245000
         BR    R14               AND HEAD BACK                          00246000
         DS    0F                   ALIGN ROUTINE ON FULLWORD           00247000
*                                                                       00248000
* VM CHANNEL INTERRUPT HANDLER                                          00249000
*                                                                       00250000
INTHNDL  EQU   *                                                        00251000
         USING *,R15                 USE ENTRY ADDRESS AS BASE          00252000
         ST    R2,CSW                SAVE UPPER HALF OF CSW             00253000
         ST    R3,CSW+4              SAVE UNIT + CHANNEL STATUS         00254000
         TM    CSW+5,X'FF'           ERROR ON CHANNEL?                  00255000
         BNZ   INTH10                YES, SO EXIT                       00256000
         TM    CSW+4,X'02'           DID WE GET A UNIT CHECK?           00257000
         BO    INTH10                YES, SO EXIT                       00258000
         TM    CSW+4,X'80'           WAS IT ATTENTION INTERRUPT?        00259000
         BO    INTH10                YES, SO EXIT                       00260000
         TM    CSW+4,X'04'           DID WE GET DEVICE END YET?         00261000
         BO    INTH10                YES, SO EXIT                       00262000
         BR    R14                   WAIT FOR VM TO GIVE DEV. END       00263000
INTH10   EQU   *                                                        00264000
         XR    R15,R15               CLEAR R15 - WE ARE DONE            00265000
         BR    R14                   AND EXIT                           00266000
         DROP  R15                   DROP BASE REGISTER                 00267000
*                                                                       00268000
* PROGRAM DATA                                                          00269000
*                                                                       00270000
         DS    0F                 ALIGN DATA AREA                       00271000
MAINSAVE DS    18F                REGISTER SAVE AREA                    00272000
RETCODE  DC    F'0'               RETURN CODE VALUE                     00273000
RETADDR  DS    F                  PLACE TO RETURN FROM SUBROUTINE       00274000
FILEADD  DS    F                  ADDRESS OF FILE SPEC                  00275000
WAITBUF  DS    CL2                USED FOR REPLY SPACE                  00276000
STATUS   DS    F                  PLACE TO PUT DEVICE/CHANNEL STATUS    00277000
PROMPT0  DC    C'*** INTERVENTION REQUIRED *** on printer'              00278000
PROMPT1  DC    C'Press <ENTER> when printer is ready to print again.'   00279000
         DS    0D                 ALIGN DATA                            00280000
EWCCW    CCW   X'05',OUTBUF,X'20',81       ERASE/WRITE  CCW             00281000
OUTBUF   DC    X'7B'              3270 WRITE CONTROL CHARACTER (WCC)    00282000
* THIS WILL BE CHANGED TO X'4B' FOR 132 COLUMN PRINTING                 00283000
* THE BITS USED ARE AS FOLLOWS:                                         00284000
* BIT 0 = 0 OR 1 TO MAKE BYTE PRINTABLE CHARACTER                       00285000
* BIT 1 = ALWAYS 1                                                      00286000
* BITS 2,3 = 11 FOR 80 COLUMN PRINTING, 00 FOR 132 COLUMN PRINTING      00287000
* BIT 4 = START PRINTER BIT                                             00288000
* BIT 7 = RESET MDT BITS (MDT = MODIFIED DATA TAG)                      00289000
INBUF    DC    CL133' '           SPACE FOR INPUT RECORD                00290000
         DS    0D                 ALIGN DATA                            00291000
SNSCCW   CCW   X'04',SNSBUF,X'20',4        BASIC SENSE CCW              00292000
SNSBUF   DS    F                                                        00293000
         DS    0D                 ALIGN DATA                            00294000
FFCCW    CCW   X'05',FFBUF,X'20',2   CCW TO SEND FORM FEED              00295000
FFBUF    DC    X'7B0C'        3270 WCC + FORM FEED                      00296000
MSG0     DC    C'* PRT86 V1.10 - Prints a file on a 328x printer *'     00297000
MSG1     DC    C'Usage:   PRT86 filename filetype (filemode)'           00298000
MSG2     DC    C'Testing for virtual device at X''080''...'             00299000
MSG3     DC    C'Device not attached.'                                  00300000
MSG4     DC    C'Unable to access file.'                                00301000
MSG5     DC    C'Printing... (lines longer than 132 bytes truncated)'   00302000
MSG6     DC    C'Unit check. CCW = X''05''. Sense = X''  ''.'           00303000
IPT6     EQU   *-4         INSERTION POINT FOR SENSE BYTE               00304000
MSG7     DC    C'EOJ-End of job'                                        00305000
MSG8     DC    C'Channel error. Channel status = X''  ''.'              00306000
IPT8     EQU   *-4         INSERTION POINT FOR CHANNEL STATUS           00307000
         DS    0H                 ALIGN DATA                            00308000
INFILE   FSCB BUFFER=INBUF                                              00309000
* AFTER FILE IS OPENED, FSOPEN WILL FILL IN REST OF FSCB                00310000
PRTCUU   EQU   X'080'       CHANNEL ADDRESS OF PRINTER                  00311000
CSW      EQU   X'40'        CHANNEL STATUS WORD                         00312000
VMCAW    EQU   X'48'        CHANNEL ADDRESS WORD                        00313000
*                                                                       00314000
* REGISTER EQUATES *                                                    00315000
R0       EQU   0                                                        00316000
R1       EQU   1                                                        00317000
R2       EQU   2                                                        00318000
R3       EQU   3                                                        00319000
R4       EQU   4                                                        00320000
R5       EQU   5                                                        00321000
R6       EQU   6                                                        00322000
R7       EQU   7                                                        00323000
R8       EQU   8                                                        00324000
R9       EQU   9                                                        00325000
R10      EQU   10                                                       00326000
R11      EQU   11                                                       00327000
R12      EQU   12                                                       00328000
R13      EQU   13                                                       00329000
R14      EQU   14                                                       00330000
R15      EQU   15                                                       00331000
         DS    0F            ALIGN DATA ON FULLWORD                     00332000
         LTORG                                                          00333000
         END                                                            00334000
